// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "UObject/NoExportTypes.h"
#include "StoveSDKPlugin.h"
#include "StoveSDKStruct.h"
#include "StoveSDKObject.generated.h"


/**
 * 
 */
UCLASS()
class STOVESDKPLUGIN_API UStoveSDKObject : public UObject, public FTickableGameObject
{
    GENERATED_BODY()

public:
    UStoveSDKObject();
   
    // Begin FTickableGameObject Interface.
    virtual void Tick(float DeltaTime) override;
    virtual bool IsTickable() const override;
    virtual TStatId GetStatId() const override;
    // End FTickableGameObject Interface.

	
public:
    //StovePCSDK Interface
    UFUNCTION(BlueprintCallable, Category = "StoveSDKPlugin")
        virtual FStoveResult StoveSDKInit(FStoveConfig fConfig);

    UFUNCTION(BlueprintCallable, Category = "StoveSDKPlugin")
        virtual FStoveState StoveSDKGetInitState();

    UFUNCTION(BlueprintCallable, Category = "StoveSDKPlugin")
        virtual FStoveResult StoveSDKGetToken();

    UFUNCTION(BlueprintCallable, Category = "StoveSDKPlugin")
        virtual FStoveResult StoveSDKGetUser();

    UFUNCTION(BlueprintCallable, Category = "StoveSDKPlugin")
        virtual FStoveResult StoveSDKGetOwnership();

    UFUNCTION(BlueprintCallable, Category = "StoveSDKPlugin")
        virtual FStoveResult StoveSDKUnInit();

    //StovePCSDK Event
    virtual void OnError(FStoveError fError) {};
    virtual void OnInitComplete() {};
    virtual void OnToken(FStoveToken fToken) {};
    virtual void OnUser(FStoveUser fUser) {};
    virtual void OnOwnership(int size, FStoveOwnership* fOwnershiop) {};

protected:
    FStoveResult _runcallbackResult;
    bool _isOnCallback; 
};

inline UStoveSDKObject* FindStoveSDKObject()
{
    for (TObjectIterator<UStoveSDKObject> it; it; ++it)
    {
        return *it;
    }
    return nullptr;
}
