// Copyright 1998-2019 Epic Games, Inc. All Rights Reserved.

#pragma once

#include "../../../Binaries/Thirdparty/StoveSDKPluginLibrary/include/StovePCSDK.h"
#include "Modules/ModuleManager.h"

class FStoveSDKPluginModule : public IModuleInterface
{
public:

	/** IModuleInterface implementation */
	virtual void StartupModule() override;
	virtual void ShutdownModule() override;

public:
    /** StovePCSDK Interface */
    StovePCResult Init(const StovePCConfig& config, const StovePCCallback& callback);
    StovePCInitState InitState();
    StovePCResult RunCallback();
    StovePCResult GetToken();
    StovePCResult GetUser();
    StovePCResult GetOwnership();
    StovePCResult UnInit();
    

private:
	/** Handle to the StovePCSDK dll we will load */
	void*   _stoveSDKLibraryHandle;
};

DECLARE_LOG_CATEGORY_EXTERN(LogStoveSDKPlugin, Log, All);