#pragma once

#include "CoreMinimal.h"
#include "Modules/ModuleManager.h"
#include "Engine.h"
#include "../../../Binaries/Thirdparty/StoveSDKPluginLibrary/include/StovePCDefine.h"
#include "StoveSDKStruct.generated.h"

USTRUCT(BlueprintType)
struct FStoveResult
{
    GENERATED_USTRUCT_BODY()

    UPROPERTY()
    int result;
};

USTRUCT(BlueprintType)
struct FStoveError
{
    GENERATED_USTRUCT_BODY()

    UPROPERTY()
    int functionType;

    UPROPERTY()
    FStoveResult result;

    UPROPERTY()
    FString message;

    UPROPERTY()
    int externalError;
};


USTRUCT(BlueprintType)
struct FStoveToken
{
    GENERATED_USTRUCT_BODY()

    UPROPERTY()
    FString token;
};

USTRUCT(BlueprintType)
struct FStoveUser
{
    GENERATED_USTRUCT_BODY()

    UPROPERTY()
    uint64 memberNo;

    UPROPERTY()
    FString nickname;

    UPROPERTY()
    FString gameUserId;
};

USTRUCT(BlueprintType)
struct FStoveOwnership
{
    GENERATED_USTRUCT_BODY()

    UPROPERTY()
    FString gameId;

    UPROPERTY()
    int gameCode;

    UPROPERTY()
    int ownershipCode;

    UPROPERTY()
    uint64 purchaseDate;

    UPROPERTY()
    uint64 memberNo;
};

USTRUCT(BlueprintType)
struct FStoveConfig
{
    GENERATED_USTRUCT_BODY()

    UPROPERTY()
    FString env;

    UPROPERTY()
    FString appKey;

    UPROPERTY()
    FString secretKey;

    UPROPERTY()
    FString gameId;

    UPROPERTY()
    int logLevel;

    UPROPERTY()
    FString logPath;
};


USTRUCT(BlueprintType)
struct FStoveState
{
GENERATED_USTRUCT_BODY()

    UPROPERTY()
    int state;
};