// Fill out your copyright notice in the Description page of Project Settings.

using System.IO;
using UnrealBuildTool;

public class StoveSDKPluginLibrary : ModuleRules
{
	public StoveSDKPluginLibrary(ReadOnlyTargetRules Target) : base(Target)
	{
		Type = ModuleType.External;
        string StoveThirdPath = Path.Combine(ModuleDirectory, "../../../Binaries/ThirdParty/StoveSDKPluginLibrary");
        string StoveLibPath = "";
        if (Target.Platform == UnrealTargetPlatform.Win64)
		{
            StoveLibPath = Path.Combine(StoveThirdPath, "bin", "x64", "Release");
        }
        else if (Target.Platform == UnrealTargetPlatform.Win32)
        {
            StoveLibPath = Path.Combine(StoveThirdPath, "bin", "Win32", "Release");
        }

        // Add the import library
        PublicAdditionalLibraries.Add(Path.Combine(StoveLibPath, "StovePCSDK.lib"));

        // Delay-load the DLL, so we can load it from the right place first
        PublicDelayLoadDLLs.Add("StovePCSDK.dll");

        // Ensure that the DLL is staged along with the executable
        RuntimeDependencies.Add(Path.Combine(StoveLibPath, "StovePCSDK.dll"));
    }
}
